Index: src/libpspp/getl.c
===================================================================
RCS file: src/libpspp/getl.c
diff -N src/libpspp/getl.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/libpspp/getl.c	26 Nov 2006 05:09:06 -0000
@@ -0,0 +1,233 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#include <stdlib.h>
+
+#include <config.h>
+
+#include "getl.h"
+
+#include <libpspp/str.h>
+#include <libpspp/ll.h>
+#include <libpspp/version.h>
+#include <libpspp/alloc.h>
+
+#include <data/file-name.h>
+
+struct getl_source
+  {
+    struct getl_source *included_from;	/* File that this is nested inside. */
+    struct getl_source *includes;	/* File nested inside this file. */
+    
+    struct ll  ll;   /* Element in the sources list */
+
+    struct getl_interface *interface;
+  };
+
+/* List of source files. */
+static struct ll_list sources ;
+
+static struct string the_include_path;
+
+const char *
+getl_include_path (void)
+{
+  return ds_cstr (&the_include_path);
+}
+
+static struct getl_source *
+current_source (struct ll_list *list)
+{
+  const struct ll *ll = ll_head (list);
+  return ll_data (ll, struct getl_source, ll );
+}
+
+/* Initialize getl. */
+void
+getl_initialize (void)
+{
+  ll_init (&sources);
+  ds_init_cstr (&the_include_path,
+                fn_getenv_default ("STAT_INCLUDE_PATH", include_path));
+}
+
+/* Delete everything from the include path. */
+void
+getl_clear_include_path (void)
+{
+  ds_clear (&the_include_path);
+}
+
+/* Add to the include path. */
+void
+getl_add_include_dir (const char *path)
+{
+  if (ds_length (&the_include_path))
+    ds_put_char (&the_include_path, ':');
+
+  ds_put_cstr (&the_include_path, path);
+}
+
+/* Appends source S to the list of source files. */
+void
+getl_append_source (struct getl_interface *i) 
+{
+  struct getl_source *s = xzalloc (sizeof ( struct getl_source ));
+
+  s->interface = i ;
+
+  ll_push_head (&sources, &s->ll);
+}
+
+/* Nests source S within the current source file. */
+void
+getl_include_source (struct getl_interface *i) 
+{
+  struct getl_source *current = current_source (&sources);
+  struct getl_source *s = xzalloc (sizeof ( struct getl_source ));
+
+  s->interface = i;
+
+  s->included_from = current ;
+  s->includes  = NULL;
+  current->includes = s;
+
+  ll_push_head (&sources, &s->ll);
+}
+
+/* Closes the current source, and move  the current source to the 
+   next file in the chain. */
+static void
+close_source (void)
+{
+  struct getl_source *s = current_source (&sources);
+
+  if ( s->interface->close ) 
+    s->interface->close (s->interface);
+
+  ll_pop_head (&sources);
+
+  if (s->included_from != NULL)
+    current_source (&sources)->includes = NULL;
+
+  free (s);
+}
+
+/* Closes all sources until an interactive source is
+   encountered. */
+void
+getl_abort_noninteractive (void) 
+{
+  while ( ! ll_is_empty (&sources))
+    {
+      const struct getl_source *s = current_source (&sources);
+      
+      if ( !s->interface->interactive (s->interface) ) 
+	close_source ();
+    }
+}
+
+/* Returns true if the current source is interactive,
+   false otherwise. */
+bool
+getl_is_interactive (void) 
+{
+  const struct getl_source *s = current_source (&sources);
+
+  if (ll_is_empty (&sources) ) 
+    return false;
+
+  return s->interface->interactive (s->interface);
+}
+
+/* Returns the name of the current source, or NULL if there is no 
+   current source */
+const char *
+getl_source_name (void)
+{
+  const struct getl_source *s = current_source (&sources);
+
+  if ( ll_is_empty (&sources) )
+    return NULL;
+
+  if ( ! s->interface->name ) 
+    return NULL;
+
+  return s->interface->name (s->interface);
+}
+
+/* Returns the location within the current source, or -1 if there is
+   no current source */
+int
+getl_source_location (void)
+{
+  const struct getl_source *s = current_source (&sources);
+
+  if ( ll_is_empty (&sources) )
+    return -1;
+
+  if ( !s->interface->location )
+    return -1;
+
+  return s->interface->location (s->interface);
+}
+
+
+/* Close getl. */
+void
+getl_uninitialize (void)
+{
+  while ( !ll_is_empty (&sources))
+    close_source ();
+  ds_destroy (&the_include_path);
+}
+
+
+/* Reads a single line into LINE.
+   Returns true when a line has been read, false at end of input.
+   If INTERACTIVE is non-null, then when true is returned
+   *INTERACTIVE will be set to true if the line was obtained
+   interactively, false otherwise. */
+bool
+do_read_line (struct string *line, bool *interactive)
+{
+  while (!ll_is_empty (&sources))
+    {
+      struct getl_source *s = current_source (&sources);
+
+      ds_clear (line);
+      if (s->interface->read (s->interface, line))
+        {
+          if (interactive != NULL)
+            *interactive = s->interface->interactive (s->interface);
+
+          while ((s))
+	    {
+	      if (s->interface->filter)
+		s->interface->filter (s->interface, line);
+	      s = s->included_from;
+	    }
+	  
+          return true;
+        }
+      close_source ();
+    }
+
+  return false;
+}
Index: src/libpspp/getl.h
===================================================================
RCS file: src/libpspp/getl.h
diff -N src/libpspp/getl.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/libpspp/getl.h	26 Nov 2006 05:09:06 -0000
@@ -0,0 +1,74 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#ifndef GETL_H
+#define GETL_H 1
+
+#include <stdbool.h>
+#include <libpspp/ll.h>
+
+struct string; 
+
+struct getl_source;
+
+
+/* An abstract base class for objects which act as line buffers for the 
+   PSPP.  Ie anything which might contain content for the lexer */
+struct getl_interface 
+  {
+    /* Returns true, if the interface is interactive */
+    bool  (*interactive) (const struct getl_interface *); 
+
+    /* Read a line from the interface */
+    bool  (*read)  (struct getl_interface *, struct string *);
+
+    /* Close and destroy the interface */
+    void  (*close) (struct getl_interface *);
+
+    /* Filter for current and all included sources.  May be NULL */
+    void  (*filter) (struct getl_interface *, struct string *line);
+
+    /* Returns the name of the source */
+    const char * (*name) (const struct getl_interface *);
+
+    /* Returns the current location within the source */
+    int (*location) (const struct getl_interface *);
+  };
+
+void getl_initialize (void);
+void getl_uninitialize (void);
+
+void getl_clear_include_path (void);
+void getl_add_include_dir (const char *);
+const char * getl_include_path (void);
+
+void getl_abort_noninteractive (void);
+bool getl_is_interactive (void);
+
+bool getl_read_line (bool *interactive);
+
+bool do_read_line (struct string *line, bool *interactive);
+
+void getl_append_source (struct getl_interface *s) ;
+void getl_include_source (struct getl_interface *s) ;
+
+const char * getl_source_name (void);
+int getl_source_location (void);
+
+#endif /* line-buffer.h */
Index: src/libpspp/message.c
===================================================================
RCS file: /sources/pspp/pspp/src/libpspp/message.c,v
retrieving revision 1.6
diff -b -w -U3 -r1.6 message.c
--- src/libpspp/message.c	18 Jul 2006 04:57:01 -0000	1.6
+++ src/libpspp/message.c	26 Nov 2006 05:09:06 -0000
@@ -19,7 +19,8 @@
 
 #include <config.h>
 
-#include <libpspp/message.h>
+#include "message.h"
+#include "msg-locator.h"
 
 #include <assert.h>
 #include <stdarg.h>
@@ -39,8 +40,6 @@
 
 /* Message handler as set by msg_init(). */
 static void (*msg_handler)  (const struct msg *);
-static void (*msg_location) (struct msg_locator *);
-
 
 /* Disables emitting messages if positive. */
 static int messages_disabled;
@@ -65,11 +64,9 @@
 }
 
 void
-msg_init ( void (*handler) (const struct msg *), 
-	   void (*location) (struct msg_locator *) ) 
+msg_init ( void (*handler) (const struct msg *) )
 {
   msg_handler = handler;
-  msg_location = location;
 }
 
 void
@@ -102,7 +99,7 @@
 void
 msg_emit (struct msg *m) 
 {
-  msg_location (&m->where);
+  get_msg_location (&m->where);
   if (!messages_disabled)
     msg_handler (m);
   free (m->text);
Index: src/libpspp/message.h
===================================================================
RCS file: /sources/pspp/pspp/src/libpspp/message.h,v
retrieving revision 1.13
diff -b -w -U3 -r1.13 message.h
--- src/libpspp/message.h	18 Jul 2006 04:57:01 -0000	1.13
+++ src/libpspp/message.h	26 Nov 2006 05:09:06 -0000
@@ -86,8 +86,7 @@
   };
 
 /* Initialization. */
-void msg_init ( void (*handler) (const struct msg *), 
-		void (*location) (struct msg_locator *) ) ;
+void msg_init ( void (*handler) (const struct msg *) );
 
 void msg_done (void);
 
Index: src/libpspp/msg-locator.c
===================================================================
RCS file: src/libpspp/msg-locator.c
diff -N src/libpspp/msg-locator.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/libpspp/msg-locator.c	26 Nov 2006 05:09:06 -0000
@@ -0,0 +1,85 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+#include <config.h>
+#include <stdlib.h>
+#include <libpspp/alloc.h>
+#include "msg-locator.h"
+#include <libpspp/message.h>
+#include <libpspp/assertion.h>
+#include "getl.h"
+
+/* File locator stack. */
+static const struct msg_locator **file_loc;
+
+static int nfile_loc, mfile_loc;
+
+void
+msg_locator_done (void)
+{
+  free(file_loc);
+  file_loc = NULL;
+  nfile_loc = mfile_loc = 0;
+}
+
+
+/* File locator stack functions. */
+
+/* Pushes F onto the stack of file locations. */
+void
+msg_push_msg_locator (const struct msg_locator *loc)
+{
+  if (nfile_loc >= mfile_loc)
+    {
+      if (mfile_loc == 0)
+	mfile_loc = 8;
+      else
+	mfile_loc *= 2;
+
+      file_loc = xnrealloc (file_loc, mfile_loc, sizeof *file_loc);
+    }
+
+  file_loc[nfile_loc++] = loc;
+}
+
+/* Pops F off the stack of file locations.
+   Argument F is only used for verification that that is actually the
+   item on top of the stack. */
+void
+msg_pop_msg_locator (const struct msg_locator *loc)
+{
+  assert (nfile_loc >= 0 && file_loc[nfile_loc - 1] == loc);
+  nfile_loc--;
+}
+
+/* Puts the current file and line number into LOC, or NULL and -1 if
+   none. */
+void
+get_msg_location (struct msg_locator *loc)
+{
+  if (nfile_loc)
+    {
+      *loc = *file_loc[nfile_loc - 1];
+    }
+  else
+    {
+      loc->file_name = getl_source_name ();
+      loc->line_number = getl_source_location ();
+    }
+}
Index: src/libpspp/msg-locator.h
===================================================================
RCS file: src/libpspp/msg-locator.h
diff -N src/libpspp/msg-locator.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/libpspp/msg-locator.h	26 Nov 2006 05:09:06 -0000
@@ -0,0 +1,36 @@
+/* PSPP - computes sample statistics.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
+   Written by Ben Pfaff <blp@gnu.org>.
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
+   WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+   02110-1301, USA. */
+
+struct msg_locator ;
+
+void msg_locator_done (void);
+
+/* File locator stack functions. */
+
+/* Pushes F onto the stack of file locations. */
+void msg_push_msg_locator (const struct msg_locator *loc);
+
+/* Pops F off the stack of file locations.
+   Argument F is only used for verification that that is actually the
+   item on top of the stack. */
+void msg_pop_msg_locator (const struct msg_locator *loc);
+
+/* Puts the current file and line number into LOC, or NULL and -1 if
+   none. */
+void get_msg_location (struct msg_locator *loc);
Index: src/ui/flexifile.c
===================================================================
RCS file: /sources/pspp/pspp/src/ui/flexifile.c,v
retrieving revision 1.3
diff -b -w -U3 -r1.3 flexifile.c
--- src/ui/flexifile.c	14 Nov 2006 11:47:17 -0000	1.3
+++ src/ui/flexifile.c	26 Nov 2006 05:09:06 -0000
@@ -22,6 +22,7 @@
 #include <xalloc.h>
 #include <assert.h>
 #include "flexifile.h"
+#include <string.h>
 #include <data/casefile.h>
 #include <data/casefile-private.h>
 #include <data/case.h>
Index: src/ui/gui/message-dialog.c
===================================================================
RCS file: /sources/pspp/pspp/src/ui/gui/message-dialog.c,v
retrieving revision 1.14
diff -b -w -U3 -r1.14 message-dialog.c
--- src/ui/gui/message-dialog.c	4 Jul 2006 04:39:05 -0000	1.14
+++ src/ui/gui/message-dialog.c	26 Nov 2006 05:09:06 -0000
@@ -29,6 +29,7 @@
 #define N_(msgid) msgid
 
 #include <libpspp/message.h>
+#include <libpspp/msg-locator.h>
 #include "message-dialog.h"
 #include "progname.h"
 
@@ -49,22 +50,13 @@
 static GQueue *message_queue;
 
 
-static void 
-msg_location (struct msg_locator *loc)
-{
-  loc->file_name = NULL; 
-  loc->line_number = -1;
-}
-
-
 void
 message_dialog_init (void) 
 {
   message_queue = g_queue_new();
-  msg_init (enqueue_msg, msg_location);
+  msg_init (enqueue_msg);
 }
 
-
 void
 message_dialog_done (void)
 {
Index: src/ui/gui/psppire.c
===================================================================
RCS file: /sources/pspp/pspp/src/ui/gui/psppire.c,v
retrieving revision 1.19
diff -b -w -U3 -r1.19 psppire.c
--- src/ui/gui/psppire.c	3 Nov 2006 04:53:52 -0000	1.19
+++ src/ui/gui/psppire.c	26 Nov 2006 05:09:06 -0000
@@ -27,6 +27,7 @@
 #include <libpspp/copyleft.h>
 #include <data/format.h>
 #include <data/settings.h>
+#include <libpspp/getl.h>
 
 #include <getopt.h>
 #include <gtk/gtk.h>
@@ -113,11 +114,9 @@
 
   glade_init();
 
-
-
   fmt_init();
   settings_init();
-
+  getl_initialize ();
   message_dialog_init();
 
   the_dictionary = psppire_dict_new();
@@ -169,6 +168,7 @@
   /* start the event loop */
   gtk_main();
 
+  getl_uninitialize ();
   message_dialog_done();
 
   settings_done();
Index: src/ui/terminal/command-line.c
===================================================================
RCS file: /sources/pspp/pspp/src/ui/terminal/command-line.c,v
retrieving revision 1.7
diff -b -w -U3 -r1.7 command-line.c
--- src/ui/terminal/command-line.c	7 Nov 2006 12:59:59 -0000	1.7
+++ src/ui/terminal/command-line.c	26 Nov 2006 05:09:06 -0000
@@ -30,15 +30,16 @@
 #include <libpspp/assertion.h>
 #include <libpspp/copyleft.h>
 #include <libpspp/message.h>
-#include <language/line-buffer.h>
+#include <language/syntax-file.h>
 #include "progname.h"
 #include <data/settings.h>
-#include "read-line.h"
 #include <output/output.h>
 #include <data/file-name.h>
+#include <libpspp/getl.h>
 #include <libpspp/str.h>
 #include <libpspp/version.h>
 #include <libpspp/verbose-msg.h>
+#include "read-line.h"
 
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
@@ -194,7 +195,8 @@
       char *pspprc_fn = fn_search_path ("rc", config_path, NULL);
       if (pspprc_fn != NULL) 
         {
-          getl_append_syntax_file (pspprc_fn);
+	  getl_append_source (create_syntax_file_source (pspprc_fn));
+
           free (pspprc_fn); 
         }
     }
@@ -204,12 +206,12 @@
       outp_configure_macro (argv[i]);
     else 
       {
-        getl_append_syntax_file (argv[i]);
+	getl_append_source (create_syntax_file_source (argv[i]));
         syntax_files++;
       }
 
   if (!syntax_files || interactive_mode)
-    getl_append_interactive (readln_read);
+    getl_append_source (create_readln_source () );
 
   return true;
 }
Index: src/ui/terminal/main.c
===================================================================
RCS file: /sources/pspp/pspp/src/ui/terminal/main.c,v
retrieving revision 1.22
diff -b -w -U3 -r1.22 main.c
--- src/ui/terminal/main.c	16 Nov 2006 12:47:22 -0000	1.22
+++ src/ui/terminal/main.c	26 Nov 2006 05:09:06 -0000
@@ -28,8 +28,10 @@
 #include "progname.h"
 #include "read-line.h"
 
+
 #include <data/dictionary.h>
 #include <data/file-handle-def.h>
+#include <libpspp/getl.h>
 #include <data/file-name.h>
 #include <data/format.h>
 #include <data/procedure.h>
@@ -38,7 +40,7 @@
 #include <gsl/gsl_errno.h>
 #include <language/command.h>
 #include <language/lexer/lexer.h>
-#include <language/line-buffer.h>
+#include <language/prompt.h>
 #include <libpspp/compiler.h>
 #include <libpspp/message.h>
 #include <libpspp/version.h>
@@ -94,6 +96,7 @@
   fn_init ();
   fh_init ();
   getl_initialize ();
+  init_prompts ();
   readln_initialize ();
   settings_init ();
   random_init ();
@@ -194,6 +197,7 @@
       fh_done ();
       lex_destroy (the_lexer);
       getl_uninitialize ();
+      uninit_prompts ();
       readln_uninitialize ();
 
       outp_done ();
Index: src/ui/terminal/msg-ui.c
===================================================================
RCS file: /sources/pspp/pspp/src/ui/terminal/msg-ui.c,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 msg-ui.c
--- src/ui/terminal/msg-ui.c	7 Nov 2006 12:59:59 -0000	1.5
+++ src/ui/terminal/msg-ui.c	26 Nov 2006 05:09:06 -0000
@@ -24,10 +24,14 @@
 #include "exit.h"
 #include "linebreak.h"
 
-#include <language/line-buffer.h>
+#include <libpspp/msg-locator.h>
+#include <libpspp/getl.h>
 #include <data/settings.h>
 #include <libpspp/message.h>
+#include <libpspp/str.h>
 #include <errno.h>
+#include <stdio.h>
+
 
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
@@ -65,7 +69,7 @@
 	  msg_file = stdout;
 	}
     }
-  msg_init (handle_msg, get_msg_location);
+  msg_init (handle_msg);
 }
 
 void
Index: src/ui/terminal/read-line.c
===================================================================
RCS file: /sources/pspp/pspp/src/ui/terminal/read-line.c,v
retrieving revision 1.9
diff -b -w -U3 -r1.9 read-line.c
--- src/ui/terminal/read-line.c	14 Nov 2006 11:47:17 -0000	1.9
+++ src/ui/terminal/read-line.c	26 Nov 2006 05:09:06 -0000
@@ -29,13 +29,12 @@
 #include "msg-ui.h"
 
 #include <data/file-name.h>
-#include <data/file-name.h>
 #include <data/settings.h>
 #include <language/command.h>
 #include <libpspp/message.h>
 #include <libpspp/str.h>
 #include <libpspp/version.h>
-#include <output/table.h>
+#include <language/prompt.h>
 
 #include "xalloc.h"
 
@@ -52,6 +51,16 @@
 static char **dont_complete (const char *, int, int);
 #endif /* HAVE_READLINE */
 
+
+struct readln_source 
+{
+  struct getl_interface parent ;
+
+  bool (*interactive_func) (struct string *line,
+			    enum prompt_style) ;
+};
+
+
 static bool initialised = false;
 
 /* Initialize getl. */
@@ -81,13 +90,29 @@
   initialised = false;
 
 #if HAVE_READLINE && unix
-  if (history_file != NULL)
+  if (history_file != NULL && false == get_testing_mode() )
     write_history (history_file);
   clear_history ();
   free (history_file);
 #endif
 }
 
+
+static bool
+read_interactive (struct getl_interface *s, struct string *line)
+{
+  struct readln_source *is  =
+    (struct readln_source *) s ;
+
+  return is->interactive_func (line, get_prompt_style ());
+}
+
+static bool
+always_true (const struct getl_interface *s UNUSED)
+{
+  return true;
+}
+
 /* Display a welcoming message. */
 static void
 welcome (void)
@@ -113,14 +138,19 @@
 #endif
 }
 
+
+
+
+
+
 /* Gets a line from the user and stores it into LINE.
    Prompts the user with PROMPT.
    Returns true if successful, false at end of file.
-   Suitable for passing to getl_append_interactive(). */
-bool
-readln_read (struct string *line, enum getl_prompt_style style)
+   */
+static bool
+readln_read (struct string *line, enum prompt_style style)
 {
-  const char *prompt = getl_get_prompt (style);
+  const char *prompt = get_prompt (style);
 #if HAVE_READLINE
   char *string;
 #endif
@@ -132,7 +162,7 @@
   welcome ();
 
 #if HAVE_READLINE
-  rl_attempted_completion_function = (style == GETL_PROMPT_FIRST
+  rl_attempted_completion_function = (style == PROMPT_FIRST
                                       ? complete_command_name
                                       : dont_complete);
   string = readline (prompt);
@@ -159,6 +189,29 @@
 #endif
 }
 
+
+static void
+readln_close (struct getl_interface *i)
+{
+  free (i);
+}
+
+/* Creates a source which uses readln to get its line */
+struct getl_interface *
+create_readln_source (void)
+{
+  struct readln_source *rlns  = xzalloc (sizeof (*rlns));
+
+  rlns->interactive_func = readln_read;
+
+  rlns->parent.interactive = always_true;
+  rlns->parent.read = read_interactive;
+  rlns->parent.close = readln_close;
+
+  return (struct getl_interface *) rlns;
+}
+
+
 #if HAVE_READLINE
 static char *command_generator (const char *text, int state);
 
Index: src/ui/terminal/read-line.h
===================================================================
RCS file: /sources/pspp/pspp/src/ui/terminal/read-line.h,v
retrieving revision 1.3
diff -b -w -U3 -r1.3 read-line.h
--- src/ui/terminal/read-line.h	28 Jun 2006 05:49:03 -0000	1.3
+++ src/ui/terminal/read-line.h	26 Nov 2006 05:09:06 -0000
@@ -21,11 +21,14 @@
 #define READLN_H
 
 #include <libpspp/str.h>
-#include <language/line-buffer.h>
+#include <libpspp/getl.h>
 
 void readln_initialize (void);
 void readln_uninitialize (void);
-bool readln_read (struct string *line, enum getl_prompt_style);
+
+struct getl_interface *create_readln_source (void);
+
+
 
 #endif /* READLN_H */
 
Index: tests/bugs/get-no-file.sh
===================================================================
RCS file: /sources/pspp/pspp/tests/bugs/get-no-file.sh,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 get-no-file.sh
--- tests/bugs/get-no-file.sh	11 Mar 2006 07:16:40 -0000	1.5
+++ tests/bugs/get-no-file.sh	26 Nov 2006 05:09:06 -0000
@@ -64,7 +64,7 @@
 # We use the stdinput here, because the bug seems to manifest itself only in 
 # interactive mode.
 activity="run program"
-cat $TESTFILE | $SUPERVISOR $PSPP -o raw-ascii  > /dev/null
+cat $TESTFILE | $SUPERVISOR $PSPP --testing-mode -o raw-ascii  > /dev/null
 if [ $? -ne 0 ] ; then fail ; fi
 
 pass
